#ifndef AIM__AIM_H
#define AIM__AIM_H

#include <SDL.h>
#include <stdbool.h>

typedef uint32_t pixval;

struct image {
	int cols, rows;
	pixval maxval;
	SDL_Surface *screen;
	unsigned char *bitmap;
};

static int image_rowbytes(struct image *img);
static void image_putpixel(struct image *img, int x, int y, pixval r, pixval g, pixval b);

void exercise(struct image * restrict in, struct image * restrict out);


/** Implementation: */

static inline int
image_rowbytes(struct image *img)
{
	return img->screen->pitch;
}

static inline void
image_putpixel(struct image *img, int x, int y, pixval r, pixval g, pixval b)
{
	pixval p = SDL_MapRGB(img->screen->format, r, g, b);
	memcpy(&img->bitmap[image_rowbytes(img) * y + x * img->screen->format->BytesPerPixel], &p, img->screen->format->BytesPerPixel);
}

#endif
